<?php

// Most of the query functions are similar (need to create more easy to use functions)

class mysql {
	var $connection;
	public function __construct() {
		$this->connect();
	}
	public function connect() {
		try {
			$this->connection = new PDO('mysql:host='.MYSQL_HOST.';dbname='.MYSQL_DB, MYSQL_USER, MYSQL_PASS);
		}
		catch (PDOException $e) {
			if (STATUS_DEBUG)
				$_SESSION['errors'] .= $e->getMessage().'<br />';
			$text = "# CONNECTION ERROR ".date('Y-m-d H:i:s', time())." #".NEW_LINE;
			$text .= "ERROR MESSAGE: ".$e->getMessage().NEW_LINE.NEW_LINE;
			file_put_contents(APP_BASE_DIR."/logs/mysql_error_log.txt", $text, FILE_APPEND | LOCK_EX);
		}
	}
	public function query($query) {
		try {
			$res = $this->connection->query($query);
			if (!$res) {
				$_SESSION['errors'] .= 'ERROR:nothing_found';
				return false;
			} else {
				return $res;
			}
		}
		catch (PDOException $e) {
			if (STATUS_DEBUG)
				$_SESSION['errors'] .= $e->getMessage().'<br />';
			$text = "# QUERY ERROR ".date('Y-m-d H:i:s', time())." #".NEW_LINE;
			$text .= "ERROR MESSAGE: ".$e->getMessage().NEW_LINE.NEW_LINE;
			file_put_contents(APP_BASE_DIR."/logs/mysql_error_log.txt", $text, FILE_APPEND | LOCK_EX);
		}
	}
	public function select($query, $params) {
		try {
			$res = $this->connection->prepare($query);
			$res->execute($params);
			if (!$res) {
				return false;
			} else {
				return $res;
			}
		}
		catch (PDOException $e) {
			if (STATUS_DEBUG)
				$_SESSION['errors'] .= $e->getMessage().'<br />';
			$text = "# SELECT QUERY ERROR ".date('Y-m-d H:i:s', time())." #".NEW_LINE;
			$text .= "ERROR MESSAGE: ".$e->getMessage().NEW_LINE.NEW_LINE;
			file_put_contents(APP_BASE_DIR."/logs/mysql_error_log.txt", $text, FILE_APPEND | LOCK_EX);
		}
	}
	public function selectLastEntryId($table, $field_name='', $field_value='', $order_by='id') {
		try {
			if ($field_name && $field_value) {
				$res = $this->connection->prepare("SELECT `id` FROM $table WHERE `$field_name`=$field_value ORDER BY `id` DESC LIMIT 1");
			} else {
				$res = $this->connection->prepare("SELECT `$order_by` FROM `$table` ORDER BY `$order_by` DESC LIMIT 1");
			}
			$res->execute();
			if (!$res) {
				return false;
			} else {
				$ftc = $res->fetch(PDO::FETCH_ASSOC);
				if (!$ftc) {
					return false;
				} else {
					return $ftc[$order_by];
				}
			}
		}
		catch (PDOException $e) {
			if (STATUS_DEBUG)
				$_SESSION['errors'] .= $e->getMessage().'<br />';
			$text = "# SELECT QUERY ERROR ".date('Y-m-d H:i:s', time())." #".NEW_LINE;
			$text .= "ERROR MESSAGE: ".$e->getMessage().NEW_LINE.NEW_LINE;
			file_put_contents(APP_BASE_DIR."/logs/mysql_error_log.txt", $text, FILE_APPEND | LOCK_EX);
		}
	}
	public function insert($query, $params) {
		try {
			$res = $this->connection->prepare($query);
			$success = $res->execute($params);
			if (!$res) {
				return false;
			} else {
				return $success;
			}
		}
		catch (PDOException $e) {
			if (STATUS_DEBUG)
				$_SESSION['errors'] .= $e->getMessage().'<br />';
			$text = "# INSERT QUERY ERROR ".date('Y-m-d H:i:s', time())." #".NEW_LINE;
			$text .= "ERROR MESSAGE: ".$e->getMessage().NEW_LINE.NEW_LINE;
			file_put_contents(APP_BASE_DIR."/logs/mysql_error_log.txt", $text, FILE_APPEND | LOCK_EX);
		}
	}
	public function update($query, $params) {
		try {
			$res = $this->connection->prepare($query);
			$success = $res->execute($params);
			return $success;
		}
		catch (PDOException $e) {
			if (STATUS_DEBUG)
				$_SESSION['errors'] .= $e->getMessage().'<br />';
			$text = "# UPDATE QUERY ERROR ".date('Y-m-d H:i:s', time())." #".NEW_LINE;
			$text .= "ERROR MESSAGE: ".$e->getMessage().NEW_LINE.NEW_LINE;
			file_put_contents(APP_BASE_DIR."/logs/mysql_error_log.txt", $text, FILE_APPEND | LOCK_EX);
		}
	}
	public function delete($query, $params) {
		try {
			$res = $this->connection->prepare($query);
			$success = $res->execute($params);
			return $success;
		}
		catch (PDOException $e) {
			if (STATUS_DEBUG)
				$_SESSION['errors'] .= $e->getMessage().'<br />';
			$text = "# DELETE QUERY ERROR ".date('Y-m-d H:i:s', time())." #".NEW_LINE;
			$text .= "ERROR MESSAGE: ".$e->getMessage().NEW_LINE.NEW_LINE;
			file_put_contents(APP_BASE_DIR."/logs/mysql_error_log.txt", $text, FILE_APPEND | LOCK_EX);
		}
	}
}

?>