<?php
	/*
		TODO:
		- make meta data language dependable
		- move the login check part to an external file in application folder
	*/

	function xml2assoc($xml) {
		$tree = null;
		while ($xml->read()) {
			switch ($xml->nodeType) {
				case XMLReader::END_ELEMENT:
					return $tree;
				case XMLReader::ELEMENT:
					$node = array('tag' => $xml->name, 'value' => $xml->isEmptyElement ? '' : xml2assoc($xml));
					if ($xml->hasAttributes) {
						while ($xml->moveToNextAttribute()) {
							$node['attributes'][$xml->name] = $xml->value;
						}
					}
					$tree[] = $node;
					break;
				case XMLReader::TEXT:
				case XMLReader::CDATA:
					$tree .= $xml->value;
			}
		}
		return $tree;
	}
	
	
?>
<!DOCTYPE html>
<html lang="en">
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
		<link rel="apple-touch-icon" sizes="57x57" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/apple-touch-icon-57x57.png">
		<link rel="apple-touch-icon" sizes="60x60" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/apple-touch-icon-60x60.png">
		<link rel="apple-touch-icon" sizes="72x72" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/apple-touch-icon-72x72.png">
		<link rel="apple-touch-icon" sizes="76x76" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/apple-touch-icon-76x76.png">
		<link rel="apple-touch-icon" sizes="114x114" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/apple-touch-icon-114x114.png">
		<link rel="apple-touch-icon" sizes="120x120" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/apple-touch-icon-120x120.png">
		<link rel="apple-touch-icon" sizes="144x144" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/apple-touch-icon-144x144.png">
		<link rel="apple-touch-icon" sizes="152x152" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/apple-touch-icon-152x152.png">
		<link rel="apple-touch-icon" sizes="180x180" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/apple-touch-icon-180x180.png">
		<link rel="icon" type="image/png" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/favicon-32x32.png" sizes="32x32">
		<link rel="icon" type="image/png" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/android-chrome-192x192.png" sizes="192x192">
		<link rel="icon" type="image/png" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/favicon-96x96.png" sizes="96x96">
		<link rel="icon" type="image/png" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/favicon-16x16.png" sizes="16x16">
		<link rel="manifest" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/manifest.json">
		<link rel="mask-icon" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/media/images/favicons/safari-pinned-tab.svg" color="#5bbad5">
		<meta name="msapplication-TileColor" content="#da532c">
		<meta name="msapplication-TileImage" content="mstile-144x144.png">
		<meta name="theme-color" content="#ffffff">
		<title><?php echo PAGE_DEFAULT_META_TITLE; ?></title>
		<meta name="description" content="<?php echo PAGE_DEFAULT_META_DESCRIPTION; ?>">
		<meta name="author" content="Andy">
		<!-- Fonts -->
		<link href='https://fonts.googleapis.com/css?family=Open+Sans:400,300,700,400italic' rel='stylesheet' type='text/css'>
		<link href='https://fonts.googleapis.com/css?family=Roboto:100,400,700,900&subset=latin,cyrillic,latin-ext' rel='stylesheet' type='text/css'>
		<!-- Styles -->
		<link rel="stylesheet" href="https://ajax.googleapis.com/ajax/libs/jqueryui/1.11.4/themes/smoothness/jquery-ui.css">
		<link rel="stylesheet" type="text/css" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/styles/general.css?<?php echo time(); ?>" />
	<?php if (!$page_type || security::secure_request_data($page_type)=='simple') { ?>
			<link rel="stylesheet" type="text/css" href="<?php echo WEB_BASE_URL;?>/templates/<?php echo CURRENT_TEMPLATE; ?>/styles/<?php echo $page; ?>.css?<?php echo time(); ?>" />
		<?php } ?>
		<!-- Scripts -->
		<script src="<?php echo WEB_BASE_URL; ?>/templates/<?php echo CURRENT_TEMPLATE; ?>/scripts/jquery-3.2.1.min.js" type="text/javascript"></script>
		<script src="<?php echo WEB_BASE_URL; ?>/templates/<?php echo CURRENT_TEMPLATE; ?>/scripts/fontawesome-all.min.js" type="text/javascript"></script>
		<?php if (file_exists(WEB_BASE_DIR.'/templates/'.CURRENT_TEMPLATE.'/scripts/'.$page.'.js')) { ?>
			<script src="<?php echo WEB_BASE_URL; ?>/templates/<?php echo CURRENT_TEMPLATE; ?>/scripts/<?php echo $page; ?>.js?<?php echo time(); ?>" type="text/javascript"></script>
		<?php } ?>
		<script src="<?php echo WEB_BASE_URL; ?>/templates/<?php echo CURRENT_TEMPLATE; ?>/scripts/login.js" type="text/javascript"></script>
	</head>
	<body>
		<?php
			if (!$page_type || security::secure_request_data($page_type)=='simple') {
				echo '<section id="main_wrapper">';
				require_once(APP_BASE_DIR.'/components/header.php');
				echo '<section id="main_content">';
				//echo '<pre>'; print_r($_SESSION); echo '</pre>'; die();
				if (user::isLogged() || $page!=='home') {
					require_once(APP_BASE_DIR.'/pages/'.$page.'.php');
				} else {
					require_once(APP_BASE_DIR.'/components/login.php');
				}
				echo '</section>';
				require_once(APP_BASE_DIR.'/components/footer.php');
				echo '</section>';
			} else {
			}
		?>
	</body>
</html>