<?php

/**
 * SAML 2.0 remote SP metadata for SimpleSAMLphp.
 *
 * See: https://simplesamlphp.org/docs/stable/simplesamlphp-reference-sp-remote
 */

$config = SimpleSAML\Configuration::getInstance();
$db_dsn = $config->getString('database.dsn', null);
$db_user = $config->getString('database.username', null);
$db_passwd = $config->getString('database.password', null);
$db = new PDO($db_dsn, $db_user, $db_passwd);

$vserver = $_SERVER['SERVER_NAME'];
$vparts = explode('.', $vserver);
$vhost = $vparts[0];

$query = "select sp_metadata from idps i where i.host = :host";

$stmt = $db->prepare($query);
$stmt->execute(array(':host' => $vhost));
$result = $stmt->fetchAll(PDO::FETCH_ASSOC);

foreach ($result as $row) {
  $xmldata = $row['sp_metadata'];
  SimpleSAML\Utils\XML::checkSAMLMessage($xmldata, 'saml-meta');
  $entities = SimpleSAML\Metadata\SAMLParser::parseDescriptorsString($xmldata);
  foreach ($entities as &$entity) {
    $entity = array('saml20-sp-remote' => $entity->getMetadata20SP());
  }
} 

if ($entities) {
  $output = SimpleSAML\Utils\Arrays::transpose($entities);
  $metadata = $output['saml20-sp-remote'];
} else {
  $metadata = array();
}

